<?php

# McPics Version 0.1.5
# McData, (c) 2002 mackstann

##############################################################################
############################### Configuration ################################
##############################################################################

    # how many pics per index page
    $conf['totalpics'] 	= 16;
    # how many per row on index page
    $conf['perrow'] 	= 4;
    # do you want the filenames shown on the index page?
    # set to either TRUE or FALSE
    $conf['index-filenames']	= TRUE;
    # do you want the filenames shown on the showimage ('zoomed in') page?
    $conf['showimage-filenames']= FALSE;
 
  ## IMAGE PATHS ##
  # MAKE SURE TO HAVE A TRAILING SLASH (/) AT THE END OF YOUR PATHS!!!!
  # (unless it's '')  If this part confuses you a bit, you can leave it
  # as-is, the default configuration expects your images to be in the same
  # directory as the php script that this is used by, and the thumbs in
  # the directory 'thumbs/'.
 
  # what to prepend to the image names for a directory.  if they're in the
  # same directory as this script, then leave as '' (nothing)
  $conf['imgpath'] 	= '';
 
  # SYSTEM path to images, /home/bob/www/images/, for current directory, use ./
  $conf['imgsyspath'] 	= './';
 
  # same as imgpath, except this is for your thumbs. you cannot have images and
  # thumbs in the same directory because they are named the same thing.
  $conf['thumbpath'] 	= 'thumbs/';

  # system path to your thumbs.  same concept as imgsyspath
  $conf['thumbsyspath'] 	= 'thumbs/';
  #################

##############################################################################
############# if you are not sure, DO NOT EDIT PAST THIS POINT! ##############
##############################################################################

#load custom file sizes, or set to default 120x90
if(file_exists('mcpics.sizes'))
  include('mcpics.sizes');
else {
  $conf['width'] = 120;
  $conf['height'] = 90;
}

#load the file list, or whine and die
if(file_exists("mcpics.filelist"))
  $conf['imglist'] = file("mcpics.filelist");
else
  die("where's the file list man!?  try re-running mcpics in this directory.");

#how many images do we have?
$conf['numpics'] = sizeof($conf['imglist']);

#is there an ?index= in the url? if so, use that value, otherwise 1.
$conf['index'] = (isset($_GET['index']) ? $_GET['index'] : 1);
    
### main function
function McPics($conf) {
  ### if there is a ?image=x, then show page for that image
  if (isset($_GET['image']) && $_GET['image'] > 0 && $_GET['image'] <= $conf['numpics'])
    showimage($conf);
	### otherwise, show index page
  else
    index($conf);
}

# if you have url variables in your page, and you put McPics into
# that page, this function keeps your existing url variables intact.
function urlvars() {
  if(empty($_GET)) return;

  foreach($_GET as $key=>$value) {
    if($key == "index" || $key == "image") continue;
		
    $key = urlencode(stripslashes($key));
    $value = urlencode(stripslashes($value));
		
    $urlstring .= "&$key=$value";
  }
  if(! isset($urlstring) || empty($urlstring) || $urlstring == "")
    return;
  return $urlstring;
}

### make the <<< prev 1 2 3 4 next >>> for index()
function mkindexlinks($conf) {
  ### figure out how many index pages to make
  $indexpages = ($conf['numpics'] / $conf['totalpics']);
  if($conf['numpics'] % $conf['totalpics'] != 0)
    $indexpages = intval($indexpages) + 1;

  ### <<< prev
  if($conf['index'] > 1)
    echo "\n\t\t<a class=\"index-prev\" href=\"./?index=" . ($conf['index'] - 1) . urlvars() . "\">&lt;&lt;&lt; prev</a>\n\n";
  else
    echo "\n\t\t<span class=\"index-prev-disabled\">&lt;&lt;&lt; prev</span>\n\n";
	
  ### 1 2 3 4 5 6
  for($i = 1 ; $i <= $indexpages ; $i++) {
    if($conf['index'] != $i)
      echo "\t\t&nbsp;<a class=\"index-numberlink\" href=\"./?index={$i}" . urlvars() . "\">$i</a>\n";
    else
      echo "\t\t&nbsp;<span class=\"index-numberlink-disabled\">" . $i . "</span>\n";
  }

  ### next >>>
  if($conf['index'] != $indexpages)
    echo "\n\t\t&nbsp;<a class=\"index-next\" href=\"./?index=" . ($conf['index'] + 1) . urlvars() . "\">next &gt;&gt;&gt;</a>\n";
  else
    echo "\n\t\t&nbsp;<span class=\"index-next-disabled\">next &gt;&gt;&gt;</span>\n";
}

### main index of thumbnails
function index($conf) {
  echo "\n<div class=\"index-div\">\n\n\t<div class=\"index-middlethumbs\">\n\n<table><tr>";
	
  ### figure out where we are at
  if($conf['index'] > 1)
    $start = $conf['totalpics'] * ($conf['index'] - 1) + 1;
  else
    $start = $conf['index'];

  $end = $conf['totalpics'] * $conf['index'];
	
  if($end >= $conf['numpics'])
    $end = $conf['numpics'];
	
  ### thumbnails in the middle
  $counter = 0;
  for($i = $start; $i <= $end; $i++) {
    $file = trim($conf['imglist'][$i-1]);
    $imgurl = trim($conf['thumbpath'] . $file);

    echo "\t\t<td><a href=\"./?index=" . $conf['index'] . "&amp;image={$i}" . urlvars() . "\">"
       . "<img class=\"index-img\" src=\"$imgurl\" alt=\"$imgurl\" /></a>";

    if($conf['index-filenames'] == TRUE)
      echo "\n\t\t<br /><span class=\"index-filename\">$file</span>";
		
    echo "</td>\n\n";
	        
    if (! ($i % $conf['perrow'])) {
      echo "\n\t\t</tr><tr>\n\n";
      $counter++;
    }
  }

  ### <<< prev 1 2 3 4 next >>>
  echo "\n\t\t" .      "</tr></table>"
        . "\n\n\t" . "</div>"
        . "\n\n\t" . "<div class=\"index-bottomlinks\">\n";
  mkindexlinks($conf);
  echo "\n\t" .      "</div>"
   . "\n\n" .      "</div>\n";
}

### show a specific image full size, with thumbs for navigation at bottom
function showimage($conf) {
  ### which image are we looking at?
  $image = $_GET['image'];
  $current_pic = $conf['imgpath'] . $conf['imglist'][$image - 1];
  $desc_file = $conf['imgsyspath'] . $conf['imglist'][$image - 1] . ".txt";

  ### image
  echo "\n" .   "<div class=\"showimage-div\">"
     . "\n\n\t" . "<div class=\"showimage-image\">"
     . "\n\t\t" .   "<img class=\"showimage-img\" src=\"$current_pic\" alt=\"$current_pic\" />"
     . "\n\t" .   "</div>"
     . "\n\n\t" . "<div class=\"showimage-desc\">"
     . "\n\t\t";
  
  if($conf['showimage-filenames'] == TRUE)
    echo "<p class=\"showimages-filename\">" . $conf['imglist'][$image - 1] . "</p>\n\t\t";
  @readfile($desc_file);
  echo "\t</div>";
	
  echo "\n\n\t<div class=\"showimage-bottomthumbs\">\n";

  ### 5 thumbnails and <<< prev index next >>>
  prev_next_thumbs($conf);
  echo "\t</div>\n\n</div>\n";
}

### make the 5 thumbnails at the bottom
function prev_next_thumbs($conf) {
  #figure out which 5 pics to use
  $b = $_GET['image'];
  $bottom5 = array($b-2,$b-1,$b,$b+1,$b+2);

  ### fix up the ones at the end or beginning (i.e. create loop effect)
  for($i = 0; $i <= 4; $i++) {
    switch($bottom5[$i]) {
      case(0 - 1):
        $bottom5[$i] = $conf['numpics'] - 1;
        break;
      case(0):
        $bottom5[$i] = $conf['numpics'];
        break;
      case($conf['numpics'] + 2):
        $bottom5[$i] = 2;
        break;
      case($conf['numpics'] + 1):
        $bottom5[$i] = 1;
		}

    ### assign the vars that will be used in the <a>'s / <img>'s
    $thumb[$i] = $conf['thumbpath'] . $conf['imglist'][$bottom5[$i] - 1];
    $image[$i] = $bottom5[$i];
  }
  ### and now output the html for the 5 thumbnails
  ?>
		<a href="./?index=<?php echo $conf['index'] ?>&amp;image=<?php echo $image[0]; echo urlvars(); ?>">
		<img class="showimage-thumb1" src="<?php echo $thumb[0] ?>" alt="<?php echo $thumb[0] ?>" /></a>

		<a href="./?index=<?php echo $conf['index'] ?>&amp;image=<?php echo $image[1]; echo urlvars(); ?>">
		<img class="showimage-thumb2" src="<?php echo $thumb[1] ?>" alt="<?php echo $thumb[1] ?>" /></a>

		<img class="showimage-thumb3" src="<?php echo $thumb[2] ?>" alt="<?php echo $thumb[2] ?>" />

		<a href="./?index=<?php echo $conf['index'] ?>&amp;image=<?php echo $image[3]; echo urlvars(); ?>">
		<img class="showimage-thumb4" src="<?php echo $thumb[3] ?>" alt="<?php echo $thumb[3] ?>" /></a>

		<a href="./?index=<?php echo $conf['index'] ?>&amp;image=<?php echo $image[4]; echo urlvars(); ?>">
		<img class="showimage-thumb5" src="<?php echo $thumb[4] ?>" alt="<?php echo $thumb[4] ?>" /></a>
	</div>
<?php ### and also the <<< prev index next >>> ?>

	<div class="showimage-bottomlinks">
		<a class="showimage-prev" href="<?php echo $in ?>?index=<?php echo $conf['index'] ?>&amp;image=<?php echo $image[1] ?>">&lt;&lt;&lt; prev</a>&nbsp;&nbsp;&nbsp;
		<a class="showimage-index" href="<?php echo $in ?>?index=<?php echo $conf['index'] ?>">index</a>&nbsp;&nbsp;&nbsp;
		<a class="showimage-next" href="<?php echo $in ?>?index=<?php echo $conf['index'] ?>&amp;image=<?php echo $image[3] ?>">next &gt;&gt;&gt;</a>
<?php
}

#now all this action gets packed into one little line
McPics($conf);

#peace out
?>
